#!/usr/bin/env python
# -*- coding: latin1 -*-
# Este cdigo ha sido generado por metacomp, versin 2.4beta1
import sys, re, string
class mc_error_sintaxis(Exception):
  pass
class mc_error_noEOF(Exception):
  pass
class mc_error_abandonar(Exception):
  pass
def mc_error(nt, esp):
  raise mc_error_sintaxis,(nt,esp)
def mc_abandonar():
  raise mc_error_abandonar
from analex import AnalizadorLexico
# Cdigo de usuario


#
# Mdulos:
#

import string,re
import generador
from gramatica import *
from tabla import Tabla
from errores import errores, avisos

#
# Variables globales:
#

T= Tabla()     # Tabla de smbolos
inicial= None  # Smbolo inicial
directos= []   # Terminales directos encontrados
codusuario=[]  # El cdigo del usuario
enparentesis=0 # Cierto si estamos dentro de parntesis

_nombre={
    "abre" : "un parntesis abierto",
    "accion" : "una accin semntica",
    "asterisco" : "un asterisco",
    "barra" : "una barra",
    "cierra" : "un parntesis cerrado",
    "codigo" : "un segmento de cdigo",
    "errordos" : "un tratamiento de error",
    "especificacion_lexica" : "una especificacin lxica",
    "flecha" : "una flecha",
    "interrogante" : "un interrogante",
    "mc_EOF" : "el fin de fichero",
    "noterminal" : "un smbolo no terminal",
    "pyc" : "un punto y coma",
    "terminal" : "un smbolo terminal",
    "tokenerror" : 'una palabra reservada "error"'
  }




def main():
  sys.stderr.write("Este mdulo no est preparado para ejecutarse independientemente")
  sys.exit(1)

mc_primeros= {"<Alternativa>":["abre","accion","errordos","terminal","noterminal","tokenerror"],
              "<Compilador>":["especificacion_lexica"],
              "<Elemental>":["abre","accion","errordos","terminal","noterminal"],
              "<Lineas>":["noterminal","codigo"],
              "<ParteDerecha>":["abre","accion","errordos","terminal","noterminal","tokenerror","barra"],
              "<tratEOF>":["errordos"]}
mc_siguientes= {"<Alternativa>":["cierra","barra","pyc"],
                "<Compilador>":["mc_EOF"],
                "<Elemental>":["abre","accion","errordos","terminal","noterminal","cierra","barra","pyc"],
                "<Lineas>":["mc_EOF"],
                "<ParteDerecha>":["cierra","pyc"],
                "<tratEOF>":["mc_EOF","noterminal","codigo"]}
mc_aceptables= {"<Alternativa>":["abre","accion","errordos","terminal","noterminal","tokenerror","cierra","barra","pyc"],
                "<Compilador>":["especificacion_lexica"],
                "<Elemental>":["abre","accion","errordos","terminal","noterminal"],
                "<Lineas>":["noterminal","codigo","mc_EOF"],
                "<ParteDerecha>":["abre","accion","errordos","terminal","noterminal","tokenerror","barra","cierra","pyc"],
                "<tratEOF>":["errordos","mc_EOF","noterminal","codigo"]}
mc_anulables= {"<Alternativa>": 1,
                "<Compilador>": 0,
                "<Elemental>": 0,
                "<Lineas>": 1,
                "<ParteDerecha>": 1,
                "<tratEOF>": 1}
class Atributos:
  pass
class AnalizadorSintactico:
  def __init__(self, entrada, entorno= None):
    self.mc_entorno= entorno
    self.mc_al= AnalizadorLexico(entrada)
    self.mc_al.avanza()
    self.mc_reintento=[1]
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      Compilador = Atributos()
      try:
        self.mc_analiza_Compilador(Compilador)
        if self.mc_al.actual.cat!= "mc_EOF":
          raise mc_error_noEOF
      except mc_error_sintaxis, (nt,esp):
        sys.stderr.write("Error no tratado en lnea %d:\n"% self.mc_al.actual.nlinea)
        sys.stderr.write("Estaba analizando la expansin del no terminal %s y he encontrado\n el terminal %s.\n" % (nt, self.mc_al.actual.cat))
        if len(esp)==1:
          sys.stderr.write("Slo vala un %s.\n" % esp[0])
        else:
          sys.stderr.write("Tendra que haber sido uno de los siguientes: %s.\n" % string.join(esp,","))
        sys.exit(1)
      except mc_error_noEOF:
        sys.stderr.write("Error no tratado en lnea %d:\n" % self.mc_al.actual.nlinea)
        sys.stderr.write("- He encontrado entrada donde esperaba ver el final del fichero\n")
        sys.exit(1)
      except mc_error_abandonar:
        pass
  def mc_reintentar(self):
    self.mc_reintento[-1]= 1
  def mc_analiza_Alternativa(self, Alternativa):
    mc_al= self.mc_al
    self.mc_reintento.append(1)
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      try:
        if not mc_al.actual.cat in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal', 'tokenerror', 'cierra', 'barra', 'pyc' ]:
          mc_error('<Alternativa>',['abre', 'accion', 'errordos', 'terminal', 'noterminal', 'tokenerror', 'cierra', 'barra', 'pyc'])
        if mc_al.actual.cat== 'tokenerror':
          tokenerror= tokenerror1= tokenerror_= mc_al.actual
          mc_al.avanza()
          if mc_al.actual.cat == 'accion':
            accion= accion1= accion_= mc_al.actual
            mc_al.avanza()
          else:
            errores.append(mc_al.linea(),"Despus del error debes indicar el tratamiento")
            mc_al.sincroniza(mc_siguientes["<Alternativa>"]+["accion"], mc_abandonar)
            if mc_al.actual.cat=="accion":
              accion= mc_al.actual
              mc_al.avanza()
            else:
              accion= None
          Alternativa.pd= None
          if accion!= None:
            Alternativa.error= [accion.id]
          else:
            Alternativa.error= None
          while mc_al.actual.cat== 'accion':
            accion2= accion_= mc_al.actual
            mc_al.avanza()
            Alternativa.error.append(accion2.id)
          if not mc_al.actual.cat in [ 'cierra', 'barra', 'pyc' ]:
            mc_error('<Alternativa>',['accion', 'cierra', 'barra', 'pyc'])
        elif mc_al.actual.cat in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal' ]:
          Elemental= Elemental1= Atributos()
          Elemental2= Atributos()
          self.mc_analiza_Elemental(Elemental1)
          Elemental_= Elemental1
          Alternativa.error= None
          if Elemental.pd!= None:
            l= [Elemental.pd]
          else:
            l= []
          while mc_al.actual.cat in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal' ]:
            self.mc_analiza_Elemental(Elemental2)
            Elemental_= Elemental2
            if Elemental2.pd!= None:
              l.append(Elemental2.pd)
          if not mc_al.actual.cat in [ 'cierra', 'barra', 'pyc' ]:
            mc_error('<Alternativa>',['abre', 'accion', 'errordos', 'terminal', 'noterminal', 'cierra', 'barra', 'pyc'])
          if len(l)== 0:
            Alternativa.pd= None
          elif len(l)== 1:
            Alternativa.pd= Elemental.pd
          else:
            Alternativa.pd= Secuencia(l, l[0].nl)
        else:
          Alternativa.pd= Vacia(mc_al.linea())
          Alternativa.error= None
      except mc_error_sintaxis, (mc_nt, mc_t):
        Alternativa.pd= None
        Alternativa.error= None
        if mc_al.actual.cat=="flecha":
          errores.append(mc_al.linea(), "He encontrado una flecha en un lugar incorrecto, es posible que te falte un punto y coma previo.")
          mc_al.sincroniza(mc_aceptables["<Alternativa>"], mc_abandonar)
          if mc_al.actual.cat in mc_primeros["<Alternativa>"]:
            mc_reintentar()
        else:
          mc_error(mc_nt, mc_t)
    self.mc_reintento.pop()
  def mc_analiza_Compilador(self, Compilador):
    mc_al= self.mc_al
    if not mc_al.actual.cat== 'especificacion_lexica':
      mc_error('<Compilador>',['especificacion_lexica'])
    tratEOF= tratEOF1= Atributos()
    Lineas= Lineas1= Atributos()
    global inicial, codusuario, directos
    self.G= None
    self.lexica= None
    self.codusuario= None
    especificacion_lexica= especificacion_lexica1= especificacion_lexica_= mc_al.actual
    mc_al.avanza()
    if mc_al.actual.cat == 'codigo':
      codigo= codigo1= codigo_= mc_al.actual
      mc_al.avanza()
    else:
      import analex
      codigo=analex.ComponenteLexico("codigo")
      codigo.cod= ""
    codusuario.append(codigo.cod)
    tratEOF.l= None
    self.mc_analiza_tratEOF(tratEOF1)
    tratEOF_= tratEOF1
    Lineas.l= []
    self.mc_analiza_Lineas(Lineas1)
    Lineas_= Lineas1
    self.lexica= []
    for td in directos:
      self.lexica.append((td,None,re.escape(td[1:])))
    self.lexica= self.lexica+especificacion_lexica.esp
    self.G= Gramatica(T.listanoterminales(), inicial, Lineas.l, tratEOF.l)
    self.codusuario= codusuario
  def mc_analiza_Elemental(self, Elemental):
    mc_al= self.mc_al
    if not mc_al.actual.cat in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal' ]:
      mc_error('<Elemental>',['abre', 'accion', 'errordos', 'terminal', 'noterminal'])
    if mc_al.actual.cat== 'noterminal':
      noterminal= noterminal1= noterminal_= mc_al.actual
      mc_al.avanza()
      Elemental.pd= T.noterminal(noterminal.id, noterminal.nlinea)
    elif mc_al.actual.cat in [ 'errordos', 'terminal' ]:
      error= []
      while mc_al.actual.cat== 'errordos':
        errordos= errordos1= errordos_= mc_al.actual
        mc_al.avanza()
        error.append(errordos.id)
      if not mc_al.actual.cat== 'terminal':
        mc_error('<Elemental>',['errordos', 'terminal'])
      if mc_al.actual.cat == 'terminal':
        terminal= terminal1= terminal_= mc_al.actual
        mc_al.avanza()
      else:
        mc_error('<Elemental>', ['terminal'])
      global directos
      if terminal.directo and terminal.id not in directos:
        directos.append(terminal.id)
      Elemental.pd= Terminal(terminal.id, terminal.directo, error, terminal.nlinea)
    elif mc_al.actual.cat== 'accion':
      accion= accion1= accion_= mc_al.actual
      mc_al.avanza()
      Elemental.pd= Accion(accion.id, accion.nlinea)
    else:
      ParteDerecha= ParteDerecha1= Atributos()
      abre= abre1= abre_= mc_al.actual
      mc_al.avanza()
      global enparentesis
      par= enparentesis
      enparentesis= 1
      self.mc_analiza_ParteDerecha(ParteDerecha1)
      ParteDerecha_= ParteDerecha1
      Elemental.pd= ParteDerecha.pd
      if mc_al.actual.cat == 'cierra':
        cierra= cierra1= cierra_= mc_al.actual
        mc_al.avanza()
      else:
        mc_error('<Elemental>', ['cierra'])
      enparentesis= par
      if mc_al.actual.cat in [ 'asterisco', 'interrogante' ]:
        if mc_al.actual.cat== 'asterisco':
          asterisco= asterisco1= asterisco_= mc_al.actual
          mc_al.avanza()
          if ParteDerecha.pd:
            Elemental.pd= Iteracion(ParteDerecha.pd, abre.nlinea)
        else:
          interrogante= interrogante1= interrogante_= mc_al.actual
          mc_al.avanza()
          if ParteDerecha.pd:
            Elemental.pd= Opcional(ParteDerecha.pd, abre.nlinea)
      elif mc_al.actual.cat not in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal', 'cierra', 'barra', 'pyc' ]:
        mc_error('<Elemental>', ['asterisco', 'interrogante', 'abre', 'accion', 'errordos', 'terminal', 'noterminal', 'cierra', 'barra', 'pyc'])
  def mc_analiza_Lineas(self, Lineas):
    mc_al= self.mc_al
    self.mc_reintento.append(1)
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      try:
        if not mc_al.actual.cat in [ 'noterminal', 'codigo', 'mc_EOF' ]:
          mc_error('<Lineas>',['noterminal', 'codigo', 'mc_EOF'])
        ParteDerecha= ParteDerecha1= Atributos()
        while mc_al.actual.cat in [ 'noterminal', 'codigo' ]:
          if mc_al.actual.cat== 'noterminal':
            noterminal= noterminal1= noterminal_= mc_al.actual
            mc_al.avanza()
            global inicial
            nt= T.noterminal(noterminal.id, noterminal.nlinea)
            if inicial== None:
              inicial= nt
            if mc_al.actual.cat == 'flecha':
              flecha= flecha1= flecha_= mc_al.actual
              mc_al.avanza()
            else:
              errores.append(mc_al.linea(), "Despus del no terminal, debera venir una flecha")
            global enparentesis
            enparentesis= 0
            self.mc_analiza_ParteDerecha(ParteDerecha1)
            ParteDerecha_= ParteDerecha1
            if mc_al.actual.cat == 'pyc':
              pyc= pyc1= pyc_= mc_al.actual
              mc_al.avanza()
            else:
              errores.append(mc_al.linea(), "Falta un punto y coma.")
              if mc_al.actual.cat=="flecha":
                errores.append(mc_al.linea(), "Creo que he juntado dos reglas.")
                mc_al.avanza()
              else:
                mc_al.sincroniza(mc_aceptables["<Lineas>"], mc_abandonar)
            if ParteDerecha.pd:
              Lineas.l.append(Regla(nt, ParteDerecha.pd, noterminal.nlinea))
            if ParteDerecha.error:
              nt.tratamientoError(ParteDerecha.error)
          else:
            codigo= codigo1= codigo_= mc_al.actual
            mc_al.avanza()
            global codusuario
            codusuario.append(codigo.cod)
        if not mc_al.actual.cat== 'mc_EOF':
          mc_error('<Lineas>',['noterminal', 'codigo', 'mc_EOF'])
      except mc_error_sintaxis, (mc_nt, mc_t):
        errores.append(mc_al.linea(), "Has comenzado una produccin de manera extraa, buscar algn comienzo")
        mc_al.sincroniza(mc_aceptables["<Lineas>"], mc_abandonar)
        mc_reintentar
    self.mc_reintento.pop()
  def mc_analiza_ParteDerecha(self, ParteDerecha):
    mc_al= self.mc_al
    self.mc_reintento.append(1)
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      try:
        if not mc_al.actual.cat in [ 'abre', 'accion', 'errordos', 'terminal', 'noterminal', 'tokenerror', 'barra', 'cierra', 'pyc' ]:
          mc_error('<ParteDerecha>',['abre', 'accion', 'errordos', 'terminal', 'noterminal', 'tokenerror', 'barra', 'cierra', 'pyc'])
        Alternativa= Alternativa1= Atributos()
        Alternativa2= Atributos()
        ParteDerecha.error= None
        self.mc_analiza_Alternativa(Alternativa1)
        Alternativa_= Alternativa1
        if Alternativa.pd:
          l= [Alternativa.pd]
        else:
          l= []
          ParteDerecha.error= Alternativa.error
        while mc_al.actual.cat== 'barra':
          barra= barra1= barra_= mc_al.actual
          mc_al.avanza()
          self.mc_analiza_Alternativa(Alternativa2)
          Alternativa_= Alternativa2
          if Alternativa2.pd:
            l.append(Alternativa2.pd)
          else:
            if ParteDerecha.error!= None:
              avisos.append(mc_al.linea(), "Ya tena un tratamiento de error; pasar de este de aqu.")
            else:
              ParteDerecha.error= Alternativa2.error
        if not mc_al.actual.cat in [ 'cierra', 'pyc' ]:
          mc_error('<ParteDerecha>',['barra', 'cierra', 'pyc'])
        if len(l)== 0:
          ParteDerecha.pd= None
        elif len(l)== 1 and ParteDerecha.error== None:
          ParteDerecha.pd= l[0]
        else:
          ParteDerecha.pd= Disyuncion(l, l[0].nl, ParteDerecha.error)
      except mc_error_sintaxis, (mc_nt, mc_t):
        if mc_al.actual.cat=="codigo":
          mensaje= "Parte derecha de la regla incorrecta: te has olvidado del punto y coma? "
        else:
          mensaje= "Parte derecha de la regla incorrecta: esperaba ver "
          if len(mc_t)> 1:
            coma=""
            if not enparentesis:
              try:
                del(mc_t[mc_t.index("cierra")])
              except ValueError:
                pass
            for i in mc_t[:-1]:
          	 mensaje= mensaje+coma+_nombre[i]
          	 coma=", "
            mensaje= mensaje+" o "+_nombre[mc_t[-1]]
          else:
            mensaje= mensaje+_nombre[mc_t[0]]
          mensaje= mensaje + " y he visto "+_nombre[mc_al.actual.cat]
        errores.append(mc_al.linea(), mensaje)
        mc_al.sincroniza(mc_siguientes["<ParteDerecha>"], mc_abandonar)
        ParteDerecha.pd= None
        ParteDerecha.error= None
    self.mc_reintento.pop()
  def mc_analiza_tratEOF(self, tratEOF):
    mc_al= self.mc_al
    self.mc_reintento.append(1)
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      try:
        if not mc_al.actual.cat in [ 'errordos', 'mc_EOF', 'noterminal', 'codigo' ]:
          mc_error('<tratEOF>',['errordos', 'mc_EOF', 'noterminal', 'codigo'])
        l=[]
        while mc_al.actual.cat== 'errordos':
          errordos= errordos1= errordos_= mc_al.actual
          mc_al.avanza()
          l.append(errordos.id)
        if not mc_al.actual.cat in [ 'mc_EOF', 'noterminal', 'codigo' ]:
          mc_error('<tratEOF>',['errordos', 'mc_EOF', 'noterminal', 'codigo'])
        tratEOF.l= l
      except mc_error_sintaxis, (mc_nt, mc_t):
        errores.append(mc_al.linea(), "Al cdigo inicial no le sigue el comienzo de una regla ni un tratamiento de error. Voy a saltar entrada hasta que encuentre algo.")
        mc_al.sincroniza(mc_primeros["<Lineas>"]+["errordos"], mc_abandonar)
        if mc_al.actual.cat=="errordos":
          mc_reintentar()
    self.mc_reintento.pop()

if __name__=="__main__":
  try:
    mc_main= main
  except NameError:
    def mc_main():
      AnalizadorSintactico(sys.stdin)
  mc_main()
