#!/usr/bin/env python
# Este cdigo ha sido generado por metacomp, versin 2.2
import sys, re, string
class mc_error_sintaxis(Exception):
  pass
class mc_error_noEOF(Exception):
  pass
class mc_error_abandonar(Exception):
  pass
def mc_error(nt, esp):
  raise mc_error_sintaxis,(nt,esp)
def mc_abandonar():
  raise mc_error_abandonar
class ComponenteLexico:
  def __init__(self, cat, lexema, nlinea):
    self.cat= cat
    self.lexema= lexema
    self.nlinea= nlinea
  def __repr__(self):
    s = ['[' + `self.cat`+': ']
    for k, v in self.__dict__.items():
      if k != 'cat': s.append('('+`k`+':'+`v`+')')
    s.append(']')
    return string.join(s)
class AnalizadorLexico:
  def __init__(self, entrada):
    self.esp=[
      ("!(", None, re.compile('\\('))
      ,("!)", None, re.compile('\\)'))
      ,("cadena", trataCadena, re.compile('"([^"\\n]|"")*"'))
      ,(None, None, re.compile('[ \\t\\n]+'))
      ,("corchete", None, re.compile('\\]'))
    ]
    if type(entrada)==type(''):
      self.l= entrada
    else:
      ll= entrada.readlines()
      self.l= string.join(ll,'')
      entrada.close()
    self.nlactual = 1
    self.actual = ComponenteLexico(None,None,0)
    try:
      self.error_lexico= error_lexico
    except:
      self.error_lexico= self._error_lexico
  def _error_lexico(self, linea_error, cars):
    sys.stderr.write("Error lxico no tratado en lnea %d: No esperaba %s.\n" % (linea_error, repr(cars)))
    sys.exit(1)
  def linea(self):
    return self.actual.nlinea
  def sincroniza(self, sincr, enEOF= mc_abandonar):
    while self.actual.cat not in sincr and self.actual.cat!= "mc_EOF":
      self.avanza()
    if self.actual.cat=="mc_EOF" and not "mc_EOF" in sincr:
      enEOF()
  def avanza(self):
    if self.l=="":
      self.actual = ComponenteLexico("mc_EOF", "", self.nlactual)
      return self.actual
    cars_inesperados, linea_error = [], 0
    while 1:
      nl= self.nlactual
      max_lon, ff = 0, None
      for (cat, f, er) in self.esp:
        m = er.match(self.l)
        if m:
          if max_lon < m.end(): max_lon, cc, ff = m.end(), cat, f
      if max_lon > 0:
        if cars_inesperados:
          self.error_lexico(linea_error, string.join(cars_inesperados,""))
          cars_inesperados, linea_error = [], 0
        lexema= self.l[:max_lon]
        self.actual = ComponenteLexico(cc, lexema, nl)
        for i in lexema:
          if i=="\n":
            self.nlactual=self.nlactual+1
        self.l = self.l[max_lon:]
        if ff:
          ff(self.actual)
        if cc:
          return self.actual
        continue
      else:
        if self.l=="":
          if cars_inesperados:
            self.error_lexico(linea_error, string.join(cars_inesperados,""))
          self.actual = ComponenteLexico("mc_EOF","",self.nlactual)
          return self.actual
        if not linea_error: linea_error = self.nlactual
        cars_inesperados.append(self.l[0])
        self.l= self.l[1:]
    
# Cdigo de usuario


def trataCadena (cad):
  cad.cad= string.replace(cad.lexema[1:-1], '""', '"')

def error_lexico(linea, cadena):
  if len(cadena)==1:
    error("Carcter %s inesperado en lnea %d." % (repr(cadena), linea))
  else:
    error("Caracteres %s inesperados en lnea %d." % (repr(cadena), linea))

class vAExcepcion(Exception):
  def __init__(self, mensaje):
    self.mensaje= mensaje

  def __str__(self):
    return self.mensaje

def error(mensaje):
  raise vAExcepcion(mensaje)


mc_primeros= {"<Arbol>":["!("],
              "<Entrada>":["!("]}
mc_siguientes= {"<Arbol>":["!)","!(","mc_EOF"],
                "<Entrada>":["mc_EOF"]}
mc_aceptables= {"<Arbol>":["!("],
                "<Entrada>":["!("]}
mc_anulables= {"<Arbol>": 0,
                "<Entrada>": 0}
class Atributos:
  pass
class AnalizadorSintactico:
  def __init__(self, entrada):
    self.mc_al= AnalizadorLexico(entrada)
    self.mc_al.avanza()
    self.mc_reintento=[1]
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      Entrada = Atributos()
      try:
        self.mc_analiza_Entrada(Entrada)
        if self.mc_al.actual.cat!= "mc_EOF":
          raise mc_error_noEOF
      except mc_error_sintaxis, (nt,esp):
        sys.stderr.write("Error no tratado en lnea %d:\n"% self.mc_al.actual.nlinea)
        sys.stderr.write("Estaba analizando la expansin del no terminal %s y he encontrado\n el terminal %s.\n" % (nt, self.mc_al.actual.cat))
        if len(esp)==1:
          sys.stderr.write("Slo vala un %s.\n" % esp[0])
        else:
          sys.stderr.write("Tendra que haber sido uno de los siguientes: %s.\n" % string.join(esp,","))
        sys.exit(1)
      except mc_error_noEOF:
        sys.stderr.write("Error no tratado en lnea %d:\n" % self.mc_al.actual.nlinea)
        sys.stderr.write("- He encontrado entrada donde esperaba ver el final del fichero")
        sys.exit(1)
      except mc_error_abandonar:
        pass
  def mc_reintentar(self):
    self.mc_reintento[-1]= 1
  def mc_analiza_Arbol(self, Arbol):
    mc_al= self.mc_al
    self.mc_reintento.append(1)
    mc_reintentar= self.mc_reintentar
    while self.mc_reintento[-1]:
      self.mc_reintento[-1]= 0
      try:
        if not mc_al.actual.cat== '!(':
          mc_error('<Arbol>',['!('])
        Arbol1= Atributos()
        mc_al.avanza()
        if mc_al.actual.cat == 'cadena':
          cadena= cadena1= cadena_= mc_al.actual
          mc_al.avanza()
        else:
          mc_error('<Arbol>', ['cadena'])
        Arbol.arbol=[cadena.cad]
        while mc_al.actual.cat== 'cadena':
          cadena2= cadena_= mc_al.actual
          mc_al.avanza()
          Arbol.arbol.append(cadena2.cad)
        if not mc_al.actual.cat in [ '!)', '!(' ]:
          mc_error('<Arbol>',['cadena', '!)', '!('])
        while mc_al.actual.cat== '!(':
          Arbol1.nivel= Arbol.nivel+1
          self.mc_analiza_Arbol(Arbol1)
          Arbol_= Arbol1
          Arbol.arbol.append(Arbol1.arbol)
        if not mc_al.actual.cat== '!)':
          mc_error('<Arbol>',['!(', '!)'])
        if mc_al.actual.cat == '!)':
          mc_al.avanza()
        else:
          mc_error('<Arbol>', ['!)'])
      except mc_error_sintaxis, (mc_nt, mc_t):
        if mc_al.actual.cat=="corchete":             
          if Arbol.nivel:                            
            return                                   
          else:                                      
            mc_al.sincroniza(mc_primeros["<Arbol>"]+["mc_EOF"]) 
        else:                                        
          error("Error sintctico en lnea %d\n" % mc_al.actual.nlinea)
    self.mc_reintento.pop()
  def mc_analiza_Entrada(self, Entrada):
    mc_al= self.mc_al
    if not mc_al.actual.cat== '!(':
      mc_error('<Entrada>',['!('])
    Arbol= Arbol1= Atributos()
    Arbol2= Atributos()
    Arbol.nivel= 0
    self.mc_analiza_Arbol(Arbol1)
    Arbol_= Arbol1
    self.arboles=[Arbol.arbol]
    while mc_al.actual.cat== '!(':
      Arbol2.nivel=0
      self.mc_analiza_Arbol(Arbol2)
      Arbol_= Arbol2
      self.arboles.append(Arbol2.arbol)
    if not mc_al.actual.cat== 'mc_EOF':
      mc_error('<Entrada>',['!(', 'mc_EOF'])

if __name__=="__main__":
  try:
    mc_main= main
  except NameError:
    def mc_main():
      AnalizadorSintactico(sys.stdin)
  mc_main()
